#include "bme2wav.h"
#include <stdio.h>
#include <string.h>

namespace BME2WAV {
  char buf[MAX_PATH];

  void edit_path( char *target, bool f_drive, bool f_dir, bool f_fname, bool f_ext ) {
    char drive[MAX_PATH], dir[MAX_PATH], fname[MAX_PATH], ext[MAX_PATH];
    
    _splitpath( target, drive, dir, fname, ext );
    target[0] = '\0';
    sprintf( target, "%s%s%s%s",
             f_drive ? drive : "",
             f_dir   ? dir   : "",
             f_fname ? fname : "",
             f_ext   ? ext   : "" );
  }

  bool get_open_filename( HWND h_wnd, char *buf, int buf_size ) {
    buf[0] = '\0';
    OPENFILENAME ofn;
    memset( &ofn, 0, sizeof( OPENFILENAME ) );
    ofn.lStructSize     = sizeof( OPENFILENAME );
    ofn.hwndOwner       = h_wnd;
    ofn.lpstrFilter     = "BMSt@C(*.bms;*.bme)\0*.*\0";
    ofn.nFilterIndex    = 1;
    ofn.lpstrFile       = buf;
    ofn.nMaxFile        = buf_size;
    ofn.lpstrFileTitle  = NULL;
    ofn.nMaxFileTitle   = 0;
    ofn.lpstrInitialDir = NULL;
    ofn.lpstrTitle      = "BMSt@CJ";
    ofn.Flags           = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_NOCHANGEDIR;
    ofn.FlagsEx         = OFN_EX_NOPLACESBAR;
    if ( !GetOpenFileName( &ofn ) ) { return false; }
    return true;
  }

  bool get_save_filename( HWND h_wnd, char *buf, int buf_size ) {
    buf[0] = '\0';
    OPENFILENAME ofn;
    memset( &ofn, 0, sizeof( OPENFILENAME ) );
    ofn.lStructSize     = sizeof( OPENFILENAME );
    ofn.hwndOwner       = h_wnd;
    ofn.lpstrFilter     = "WAVt@C(*.wav)\0*.*\0\0";
    ofn.nFilterIndex    = 1;
    ofn.lpstrFile       = buf;
    ofn.nMaxFile        = buf_size;
    ofn.lpstrFileTitle  = NULL;
    ofn.nMaxFileTitle   = 0;
    ofn.lpstrInitialDir = NULL;
    ofn.lpstrTitle      = "WAVt@Cۑ";
    ofn.Flags           = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR;
    ofn.FlagsEx         = OFN_EX_NOPLACESBAR;
    if ( !GetSaveFileName( &ofn ) ) { return false; }
    return true;
  }
}
