#ifndef _MAINFRAME_H_
#define _MAINFRAME_H_

#include "bmsfel.h"
#include "ttl.h"

#define ID_IN_BUTTON  1001
#define ID_OUT_BUTTON 1002
#define ID_EXE_BUTTON 1003

class FileEdit : public TtEdit {
protected:
  virtual DWORD  get_ex_style();
  virtual DWORD  get_style();
};


class MainFrame : public TtApp {
public:
  // static
  static const int DEFAULT_WIDTH  = 465;
  static const int DEFAULT_HEIGHT = 180;
  static const int DEFAULT_POS_X  = 0;
  static const int DEFAULT_POS_Y  = 0;
  static char *class_name;
  static bool init( HINSTANCE h_instance );

  // instance
protected:
  TtStatic   *input_label;
  TtEdit     *input_edit;
  TtButton   *input_button;
  TtStatic   *output_label;
  TtEdit     *output_edit;
  TtButton   *output_button;
  TtStatic   *volume_label;
  TtEdit     *volume_edit;
  TtProgress *progress;
  TtButton   *exec_button;
  TtStatic   *info_label;
  
  virtual DWORD  get_ex_style();
  virtual DWORD  get_style();
  virtual PCTSTR get_class_name();
  virtual bool created();

  LRESULT wm_command_recved( int id, int code, HWND child );
  LRESULT wm_dropfiles_recved( HDROP h_drop );
  LRESULT wnd_proc( UINT msg, WPARAM w_param, LPARAM l_param );
  
  bool exe_callback( int percentage );
};

#endif // _MAINFRAME_H_
